unit sensan1;
{ Sensor Monitor

  © 2019 В.Волченко, daesher@mail.ru

  Данная программа является свободным
  программным обеспечением. Вы вправе
  распространять её и/или модифицировать в
  соответствии с условиями версии 2 либо по
  вашему выбору с условиями более поздней
  версии Стандартной Общественной
  Лицензии GNU, опубликованной Free Software Foundation.

  Мы распространяем эту программу в
  надежде на то, что она будет вам полезной,
  однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЁ НИКАКИХ
  ГАРАНТИЙ, в том числе ГАРАНТИИ ТОВАРНОГО
  СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ
  ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ. Для
  получения более подробной информации
  ознакомьтесь со Стандартной
  Общественной Лицензией GNU.

  Копия Стандартной Общественной Лицензии
  GNU доступна в Интернете по адресу
  <http://www.gnu.org/copyleft/gpl.html>. Вы также можете
  получить экземпляр в Free Software Foundation, Inc., 51
  Franklin Street - Fifth Floor, Boston, MA 02110-1335, USA.
}
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Spin, snsUtils,contnrs, snsMonitor;

type

  { TSensFrm }

  TSensFrm = class(TForm)
    btnStart: TButton;
    btnStop: TButton;
    btnMonitor: TButton;
    lSensors: TLabel;
    mRaw: TMemo;
    Timer1: TTimer;
    procedure btnMonitorClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public
    PL:TParcedList;
  end;

var
  SensFrm: TSensFrm;

implementation

{$R *.lfm}

{ TSensFrm }

procedure TSensFrm.Timer1Timer(Sender: TObject);

var
  SL: TStrings;
  i: Integer;
  O: TParcerRecord;
  s, s1, s2: String;
  n: SizeInt;
begin
  Timer1.Enabled:=false;
  SL:=GetSensors;
  mRaw.Lines.Clear;
  mRaw.Lines.AddStrings(SL);
  PL.Clear;
  PL.FirstTop:=lSensors.Top+lSensors.Height+10;
  PL.FirstLeft:=lSensors.Left;
  i:=0;
  repeat
    s:=SL[i];
    if Pos('°C',s)<1 then inc(i)
    else begin
      //parsing string
      n:=pos(':',s);
      if n<1 then begin inc(i);continue;end;
      s1:=copy(s,1,n-1);
      s2:=ESCopyToEnd(s,n+1);
      n:=pos('°C',s2);
      s2:=ESCopy(s2,1,n-1);
      O:=TParcerRecord.Create(self);
      O.cmp.Parent:=self;
      O.cmp.Top:=PL.NextTop;
      O.cmp.Left:=PL.FirstLeft;
      O.cmp.Caption:=s1;
      O.Cmp.Show;
      O.ParValue.Parent:=self;
      O.ParValue.Top:=O.cmp.Top;
      O.ParValue.Left:=O.cmp.Left+O.cmp.Width+20;
      O.ParValue.Width:=60;
      O.ParValue.Value:=ESVal(s2);
      O.ParValue.Show;
      O.LineNum:=i;
      PL.Add(O);
      inc(i);
      Application.ProcessMessages;
    end;
  until i>=SL.Count;
  SL.Free;
  Timer1.Interval:=5000;
  Timer1.Enabled:=true;
end;

procedure TSensFrm.FormCreate(Sender: TObject);
begin
 PL:=TParcedList.Create(true);
end;

procedure TSensFrm.btnStartClick(Sender: TObject);
begin
  Timer1.Enabled:=true;
end;

procedure TSensFrm.btnMonitorClick(Sender: TObject);
var
  frmMon: TfrmMonitor;
  i, j: Integer;
  s: String;
begin
  j:=-1;
  for i:=0 to PL.Count-1 do
    if assigned(Pl[i].cmp) and PL[i].cmp.Checked then begin j:=PL[i].LineNum;s:=PL[i].cmp.Caption;break;end;
  if j<0 then begin
    ShowMessage('Ничего не выбрано! Мониторинга не будет!');
    exit;
  end;
  Application.CreateForm(TfrmMonitor,frmMon);
  frmMon.LineNum:=j;
  frmMon.Cap:=Trim(s);
  frmMon.StartTicks:=GetTickCount64;
  frmMon.Timer1.Enabled:=true;
  frmMon.Show;
end;

procedure TSensFrm.btnStopClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
end;

end.

