unit snsMonitor;
{ Sensor Monitor

  © 2019 В.Волченко, daesher@mail.ru

  Данная программа является свободным
  программным обеспечением. Вы вправе
  распространять её и/или модифицировать в
  соответствии с условиями версии 2 либо по
  вашему выбору с условиями более поздней
  версии Стандартной Общественной
  Лицензии GNU, опубликованной Free Software Foundation.

  Мы распространяем эту программу в
  надежде на то, что она будет вам полезной,
  однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЁ НИКАКИХ
  ГАРАНТИЙ, в том числе ГАРАНТИИ ТОВАРНОГО
  СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ
  ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ. Для
  получения более подробной информации
  ознакомьтесь со Стандартной
  Общественной Лицензией GNU.

  Копия Стандартной Общественной Лицензии
  GNU доступна в Интернете по адресу
  <http://www.gnu.org/copyleft/gpl.html>. Вы также можете
  получить экземпляр в Free Software Foundation, Inc., 51
  Franklin Street - Fifth Floor, Boston, MA 02110-1335, USA.
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  Buttons, ExtDlgs, TAGraph, TASources, TASeries, snsUtils;

type

  { TfrmMonitor }

  TfrmMonitor = class(TForm)
    Chart1: TChart;
    CoolBar1: TCoolBar;
    LineSeries: TLineSeries;
    SavePictureDialog1: TSavePictureDialog;
    Source: TListChartSource;
    SpeedButton1: TSpeedButton;
    Timer1: TTimer;
    procedure SpeedButton1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public
    LineNum:integer;
    StartTicks:QWord;
    Cap:String;
  end;

var
  frmMonitor: TfrmMonitor;

implementation

{$R *.lfm}

{ TfrmMonitor }

procedure TfrmMonitor.Timer1Timer(Sender: TObject);
var
  SL: TStrings;
  s, s2: String;
  n: SizeInt;
  X: QWord;
  Y: Double;
begin
  X:=(GetTickCount64-StartTicks) div 1000;
  if LineNum<0 then exit;
  SL:=GetSensors;
  if LineNum>=SL.Count then begin SL.Free;exit;end;
  s:=SL[LineNum];
  if Pos('°C',s)<1 then begin SL.Free;exit;end;
  n:=pos(':',s);
  if n<1 then begin SL.Free;exit;end;
  s2:=ESCopyToEnd(s,n+1);
  n:=pos('°C',s2);
  s2:=ESCopy(s2,1,n-1);
  Y:=ESVal(s2);
  Caption:=Cap+' '+IntToStr(X)+' c; '+FloatToStr(Y)+'°C';
  Source.Add(X,Y);
  Chart1.Repaint;
end;

procedure TfrmMonitor.SpeedButton1Click(Sender: TObject);
begin
  if not SavePictureDialog1.Execute then exit;
  Chart1.SaveToBitmapFile(SavePictureDialog1.FileName);
end;

end.

