unit snsUtils;
{ Sensor Monitor

  © 2019 В.Волченко, daesher@mail.ru

  Данная программа является свободным
  программным обеспечением. Вы вправе
  распространять её и/или модифицировать в
  соответствии с условиями версии 2 либо по
  вашему выбору с условиями более поздней
  версии Стандартной Общественной
  Лицензии GNU, опубликованной Free Software Foundation.

  Мы распространяем эту программу в
  надежде на то, что она будет вам полезной,
  однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЁ НИКАКИХ
  ГАРАНТИЙ, в том числе ГАРАНТИИ ТОВАРНОГО
  СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ
  ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ. Для
  получения более подробной информации
  ознакомьтесь со Стандартной
  Общественной Лицензией GNU.

  Копия Стандартной Общественной Лицензии
  GNU доступна в Интернете по адресу
  <http://www.gnu.org/copyleft/gpl.html>. Вы также можете
  получить экземпляр в Free Software Foundation, Inc., 51
  Franklin Street - Fifth Floor, Boston, MA 02110-1335, USA.
}
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Controls,StdCtrls,ExtCtrls,Spin,contnrs;
type

  { TParcerRecord }

  TParcerRecord=class(TObject)
  private
    FLineNum: integer;
    FOwner: TComponent;
  public
    cmp:TRadioButton;
    ParValue:TFloatSpinEdit;
    function IsChecked:boolean;
    property LineNum:integer read FLineNum write FLineNum;
    property Owner:TComponent read FOwner write FOwner;
    constructor Create(AOwner:TComponent);virtual;
    destructor Destroy;override;
  end;

  { TParcedList }

  TParcedList=Class(TObjectList)
  private
    FFirstLeft: integer;
    FFirstTop: integer;
    function GetItems(i: integer): TParcerRecord;
    procedure SetItems(i: integer; AValue: TParcerRecord);
  public

    property FirstTop:integer read FFirstTop write FFirstTop;
    property FirstLeft:integer read FFirstLeft write FFirstLeft;
    function Add(AObject: TParcerRecord): Integer;
    function NextTop:integer;
    property Items[i:integer]:TParcerRecord read GetItems write SetItems;default;
  end;
function ESCopy(const s:string;i,j:integer):string;//from i to j
function ESCopyToEnd(const s:string;i:integer):string;
function ESVal(const S:string):double;
Function GetSensors:TStrings;
implementation

function ESCopy(const s: string; i, j: integer): string;
begin
  Result:=copy(s,i,j-i+1);
end;

function ESCopyToEnd(const s: string; i: integer): string;
begin
  Result:=ESCopy(s,i,length(s));
end;

function ESVal(const S: string): double;
var C:integer;
begin
  Val(S,Result,c);
end;

Function GetSensors:TStrings;
var
  s, s1: String;
  sl: TStringList;
begin
    try
    s:=GetTempFileName;
    ExecuteProcess('/usr/bin/touch',s);
    s1:=GetTempFileName;
    sl:=TStringList.Create;
    SL.Add('sensors > '+s);
    SL.SaveToFile(s1);
    SL.Free;
    ExecuteProcess('/bin/sh',s1);
    Result:=TStringList.Create;
    Result.LoadFromFile(s);
  finally
    DeleteFile(s);
    DeleteFile(s1);
  end;
end;

{ TParcerRecord }

function TParcerRecord.IsChecked: boolean;
begin
  Result:=false;
  if not Assigned(cmp) then exit;
  Result:=cmp.Checked;
end;

constructor TParcerRecord.Create(AOwner: TComponent);
begin
  inherited Create;
  Owner:=AOwner;
  cmp:=TRadioButton.Create(AOwner);
  ParValue:=TFloatSpinEdit.Create(AOwner);
end;

destructor TParcerRecord.Destroy;
begin
  inherited Destroy;
  cmp.Free;
  ParValue.Free;
end;

{ TParcedList }

function TParcedList.GetItems(i: integer): TParcerRecord;
var
  O: TObject;
begin
  O:=inherited Items[i];
  if (O<>nil)and(O is TParcerRecord) then Result:=O as TParcerRecord
    else Result:=nil;
end;

procedure TParcedList.SetItems(i: integer; AValue: TParcerRecord);
begin
  inherited Items[i]:=AValue;
end;

function TParcedList.Add(AObject: TParcerRecord): Integer;
begin
  inherited Add(AObject);
end;

function TParcedList.NextTop: integer;
var
  i: Integer;
begin
  Result:=FirstTop;
  i:=Count-1;
  if i<0 then exit;
  repeat
    if self[i]=nil then dec(i) else
      begin Result:=Self[i].cmp.Top+self[i].cmp.Height+10;exit;end;
  until i<0;
end;

end.

